//---------------------------------------------------------------------------
#include <vcl.h>
#include <Registry.hpp>
#pragma hdrstop

#include "ifmmedia.h"
#include "ifmmvar.h"
#include "Unit2.h"
//---------------------------------------------------------------------------
USEFORM("Unit1.cpp", PlayForm);
USEFORM("Unit2.cpp", DialogForm);
//---------------------------------------------------------------------------
int   __fastcall GetPictureEx(const LPSTR buf, const long len, const unsigned int flag,
                   HANDLE *pHBInfo, HANDLE *pHBm,
                   const SPI_PROGRESS lpPrgressCallback,
                   const long lData, const bool IsPreview);

//O[oϐ
ifmmVar ifmmvar;
//---------------------------------------------------------------------------
int WINAPI DllEntryPoint(HINSTANCE hinst, unsigned long reason, void*)
{
    switch (reason) {
        case DLL_PROCESS_ATTACH:
            LoadOptions();
            break;
    }

    return 1;
}
//---------------------------------------------------------------------------
//ݒǂ݂
void __fastcall LoadOptions(void)
{
    IFMMVAR_STRUCT var;

/* ftHg̐ݒ */
    // ɓinjĐ
    var.option[IFMMOPT_MemoryPlay] = TRUE;
    // 킴ƃG[Ԃ
    var.option[IFMMOPT_ReturnErr]  = FALSE;
    // EBhEɑO
    var.option[IFMMOPT_StayOnTop]  = FALSE;
    // v[[ANeBu
    var.option[IFMMOPT_NoActive]   = FALSE;
    // v[[ʒuŒ
    var.option[IFMMOPT_WindowPos]  = FALSE;
    var.option[IFMMOPT_WindowPosX] = 0;
    var.option[IFMMOPT_WindowPosY] = 0;
    // v[[ŏŋN
    var.option[IFMMOPT_Minimized]  = FALSE;
    // Susieɓ̍ŏ̃t[Ԃ
    var.option[IFMMOPT_PreviewMovie] = TRUE;
    // ̃vr[ʒu(b)
    var.option[IFMMOPT_PreviewPos1] = 0;
    var.option[IFMMOPT_PreviewPos2] = 5;
    // ʒɕ\
    var.option[IFMMOPT_MovieCenter] = FALSE;
    // ̃TCY{
    var.option[IFMMOPT_MovieSize] = MS_X1;
    // debugƂ...
    var.option[IFMMOPT_DebugMode] = FALSE;
    // Susie݊ȊOgps
    var.option[IFMMOPT_SusieOnly] = TRUE;

    // JX^TCY
    var.option[IFMMOPT_MovieHeight] = Screen->DesktopHeight * 2 / 3;
    var.option[IFMMOPT_MovieWidth]  = Screen->DesktopWidth  * 2 / 3;
    var.option[IFMMOPT_MoviePosY] = ( (Screen->DesktopHeight -var.option[IFMMOPT_MovieHeight] -78/*PlayForm->Height*/) /2 );
    var.option[IFMMOPT_MoviePosX] = ( (Screen->DesktopWidth  -var.option[IFMMOPT_MovieWidth]  -(284 -276)/*PlayForm->Width  -PlayForm->ClientWidth*/)  /2 );

    //uSusie݊vH
    /*
      Susie ̂悤ɃJ^OiTlCj쐬Ƃ GetPreviewA
      ʂɕ\Ƃ GetPicture ĂяoB
      ܂ ifmm.spi ɓ삷邱ƂmFĂ\tgB
      vOCĂяoexe̖OŃ`FbN
      "susie"܂"ccnn"܂܂ĂΗǂ
      ̃\tg̓WXgɓo^
    */
    AnsiString exename = ExtractFileName(ParamStr(0)).LowerCase();
    if (  exename.AnsiPos("susie")
       || exename.AnsiPos("ccnn")
       )
    {
        var.option[IFMMOPT_IsSusie] = true;
    } else {
        var.option[IFMMOPT_IsSusie] = false;
        //WXgSusie݊`FbN
        TStringList* AppSL = new TStringList();
        GetSusieCompatiAppName(AppSL);
        int count = AppSL->Count;
        for (int i=0; i < count; i++) {
            if (exename.AnsiPos(AppSL->Strings[i].LowerCase())) {
                var.option[IFMMOPT_IsSusie] = true;
                break;
            }
        }
        delete AppSL;
    }
    // ViXōĐ
    var.option[IFMMOPT_PlayByViX] = TRUE;
    //ĂяoViXH
    if (exename.AnsiPos("vix")) {
        var.option[IFMMOPT_IsViX] = TRUE;
    } else {
        var.option[IFMMOPT_IsViX] = FALSE;
    }

    //T|[g`
    for (int i=0; i < FT_COUNT; i++) {
        var.playable[i] = true;
    }
    //̂̓ftHg̓It
    var.playable[MOVPLAY] = false;
    var.playable[OGGPLAY] = false;
    var.playable[RMPLAY] = false;


/* ݒWXgǂ݂ */
    bool ret;
    TRegistry *Reg = new TRegistry(KEY_EXECUTE);
    //Reg->RootKey = HKEY_CURRENT_USER;
    ret = Reg->OpenKey("\\Software\\shimitei\\ifmm", false);
try {
if (ret) {
    // ɓinjĐ
    if (Reg->ValueExists("Memory")) {
        var.option[IFMMOPT_MemoryPlay] = Reg->ReadBool("Memory");
    }
    // 킴ƃG[Ԃ
    if (Reg->ValueExists("Error")) {
        var.option[IFMMOPT_ReturnErr] = Reg->ReadBool("Error");
    }
    // EBhEɑO
    if (Reg->ValueExists("StayOnTop")) {
        var.option[IFMMOPT_StayOnTop] = Reg->ReadBool("StayOnTop");
    }
    // v[[ANeBu
    if (Reg->ValueExists("NoActive")) {
        var.option[IFMMOPT_NoActive] = Reg->ReadBool("NoActive");
    }
    // v[[ʒuŒ
    if (Reg->ValueExists("WindowPos")) {
        var.option[IFMMOPT_WindowPos] = Reg->ReadBool("WindowPos");
    }
    if (Reg->ValueExists("WindowPosX")) {
        var.option[IFMMOPT_WindowPosX] = Reg->ReadInteger("WindowPosX");
    }
    if (Reg->ValueExists("WindowPosY")) {
        var.option[IFMMOPT_WindowPosY] = Reg->ReadInteger("WindowPosY");
    }

    // Susieɓ̍ŏ̃t[Ԃ
    if (Reg->ValueExists("PreviewMovieFrame")) {
        var.option[IFMMOPT_PreviewMovie] = Reg->ReadBool("PreviewMovieFrame");
    }
    // ̃vr[ʒu
    if (Reg->ValueExists("PreviewPos1")) {
        var.option[IFMMOPT_PreviewPos1] = Reg->ReadInteger("PreviewPos1");
    }
    if (Reg->ValueExists("PreviewPos2")) {
        var.option[IFMMOPT_PreviewPos2] = Reg->ReadInteger("PreviewPos2");
    }
    // v[[ŏŋN
    if (Reg->ValueExists("Minimized")) {
        var.option[IFMMOPT_Minimized] = Reg->ReadBool("Minimized");
    }
    // ̃TCY{
    if (Reg->ValueExists("MovieSize")) {
        var.option[IFMMOPT_MovieSize] = Reg->ReadInteger("MovieSize");
    }
    // ʒ
    if (Reg->ValueExists("MovieCenter")) {
        var.option[IFMMOPT_MovieCenter] = Reg->ReadBool("MovieCenter");
    }

    int tmpX = 0;
    int tmpY = 0;
    int tmpH = 0;
    int tmpW = 0;
    // JX^TCY
    if (Reg->ValueExists("MoviePosX")) {
        tmpX = Reg->ReadInteger("MoviePosX");
    }
    if (Reg->ValueExists("MoviePosY")) {
        tmpY = Reg->ReadInteger("MoviePosY");
    }
    if (Reg->ValueExists("MovieHeight")) {
        tmpH = Reg->ReadInteger("MovieHeight");
    }
    if (Reg->ValueExists("MovieWidth")) {
        tmpW = Reg->ReadInteger("MovieWidth");
    }
    if (tmpH != 0 && tmpW != 0) {
        var.option[IFMMOPT_MoviePosX] = tmpX;
        var.option[IFMMOPT_MoviePosY] = tmpY;
        var.option[IFMMOPT_MovieHeight] = tmpH;
        var.option[IFMMOPT_MovieWidth]  = tmpW;
    }

    // Susie݊ȊOgps
    if (Reg->ValueExists("SusieOnly")) {
        var.option[IFMMOPT_SusieOnly] = Reg->ReadBool("SusieOnly");
    }
    //ViXōĐ
    if (Reg->ValueExists("PlayByViX")) {
        var.option[IFMMOPT_PlayByViX] = Reg->ReadBool("PlayByViX");
    }
    // fobO[h
    if (Reg->ValueExists("Debug")) {
        var.option[IFMMOPT_DebugMode] = Reg->ReadBool("Debug");
    }

    // T|[g`
    if (Reg->ValueExists("WAVE")) {
        var.playable[WAVEPLAY] = Reg->ReadBool("WAVE");
    }
    if (Reg->ValueExists("MIDI")) {
        var.playable[MIDIPLAY] = Reg->ReadBool("MIDI");
    }
    if (Reg->ValueExists("AVI")) {
        var.playable[AVIPLAY] = Reg->ReadBool("AVI");
    }
    if (Reg->ValueExists("AIFF")) {
        var.playable[AIFFPLAY] = Reg->ReadBool("AIFF");
    }
    if (Reg->ValueExists("MOV")) {
        var.playable[MOVPLAY] = Reg->ReadBool("MOV");
    }
    if (Reg->ValueExists("MPEG")) {
        var.playable[MPEGPLAY] = Reg->ReadBool("MPEG");
    }
    if (Reg->ValueExists("MPA")) {
        var.playable[MPAPLAY] = Reg->ReadBool("MPA");
    }
    if (Reg->ValueExists("AU")) {
        var.playable[AUPLAY] = Reg->ReadBool("AU");
    }
    if (Reg->ValueExists("WMA")) {
        var.playable[WMAPLAY] = Reg->ReadBool("WMA");
    }
    if (Reg->ValueExists("WMV")) {
        var.playable[WMVPLAY] = Reg->ReadBool("WMV");
    }
    if (Reg->ValueExists("ASF")) {
        var.playable[ASFPLAY] = Reg->ReadBool("ASF");
    }
    if (Reg->ValueExists("OGG")) {
        var.playable[OGGPLAY] = Reg->ReadBool("OGG");
    }
    if (Reg->ValueExists("RM")) {
        var.playable[RMPLAY] = Reg->ReadBool("RM");
    }
    Reg->CloseKey();
}
} catch (...) {
    //throw;
}
    delete Reg;

    //܂Ƃ߂Set
    ifmmvar.Setallvar(&var);
}
//---------------------------------------------------------------------------
//Susie݊o^Avǂ
//֐...
void __fastcall GetSusieCompatiAppName(TStringList* AppSL)
{
    TRegistry *Reg = new TRegistry(KEY_EXECUTE);
    //Reg->RootKey = HKEY_CURRENT_USER;
    bool ret = Reg->OpenKey("\\Software\\shimitei\\ifmm\\SusieCompati", false);
    //AppSL->Clear();
if (ret) {
    Reg->GetValueNames(AppSL);
}
    delete Reg;
}
//---------------------------------------------------------------------------
int __stdcall GetPluginInfo(int infono, LPSTR buf, int buflen)
{
    char *infomation[] = {
    /* 0     */  "00IN",
    /* 1     */  "MediaPlayer v1.27a by shimitei",
    /* 2*0+2 */  NULL, /* filemask */
    /* 2*0+3 */  "Media file",
    };

    if (infono < 0) return 0;
    if (infono < (sizeof(infomation) / sizeof(infomation[0]))) {
        if (infono == 2) {
            AnsiString filemask = "";
            bool playable[FT_COUNT];
            ifmmvar.Getplayable(playable);
            if (playable[WAVEPLAY]) filemask += "*.wav;";
            if (playable[MIDIPLAY]) filemask += "*.mid;*.midi;";
            if (playable[AVIPLAY] ) filemask += "*.avi;";
            if (playable[AIFFPLAY]) filemask += "*.aif;*,aiff;";
            if (playable[MOVPLAY] ) filemask += "*.mov;";
            if (playable[MPEGPLAY]) filemask += "*.mpg;*.mpeg;*.mpe;*.m1v;*.m2v;*.mpv2;*.mp2v;";
            if (playable[MPAPLAY] ) filemask += "*.mp3;*.mpa;*.mp2;*.m1a;*.m2a;";
            if (playable[AUPLAY]  ) filemask += "*.au;*.snd;";
            if (playable[WMAPLAY] ) filemask += "*.wma;";
            if (playable[WMVPLAY] ) filemask += "*.wmv;";
            if (playable[ASFPLAY] ) filemask += "*.asf;";
            if (playable[OGGPLAY] ) filemask += "*.ogg;";
            if (playable[RMPLAY]  ) filemask += "*.rm;*.ra;";

            if (filemask.IsEmpty()) {
                lstrcpyn(buf, "", buflen);
            } else {
                //Ō";"BKv͖H
                filemask.SetLength(filemask.Length() -1);
                lstrcpyn(buf, filemask.c_str(), buflen);
            }
        } else {
            //K'\0'H
            lstrcpyn(buf, infomation[infono], buflen);
        }
        //'\0'͐Ȃ
        return lstrlen(buf);
    }

    return 0;
}
//---------------------------------------------------------------------------
int __stdcall IsSupported(LPSTR filename, DWORD dw)
{
    char h_buff[HEAD_BUFF];
    char *data;

    if ((dw & 0xFFFF0000) == 0) {
    /* t@Cnh */
        DWORD ReadBytes;
        memset(h_buff, 0, HEAD_BUFF);
        if (!ReadFile((HANDLE)dw, h_buff, HEAD_BUFF, &ReadBytes, NULL)) {
            return 0;
        }
        data = h_buff;
    } else {
    /*  */
        data = (char *)dw;
    }

    /* Ήt@CmF */
    if (GetFileType(data, filename) != FT_UNKNOWN) {
        return 1;
    }

    return 0;
}
//---------------------------------------------------------------------------
int __stdcall GetPictureInfo
(LPSTR buf, long len, unsigned int flag, struct PictureInfo *lpInfo)
{
    //ŒԂ
    char h_buff[HEAD_BUFF];
    char *data;
    char *filename;

switch ((flag & 7)) {
    case 0: /* t@C */
    {
        HANDLE hf;
        DWORD ReadBytes;
        hf = CreateFile(buf, GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, 0, NULL);
        if (hf == INVALID_HANDLE_VALUE)
            return SPI_FILE_READ_ERROR;
        //SetFilePointer(hf, len, NULL, FILE_BEGIN);//MacoCiɂ͑ΉȂ
        if (!ReadFile(hf, h_buff, HEAD_BUFF, &ReadBytes, NULL)) {
            CloseHandle(hf);
            return SPI_FILE_READ_ERROR;
        }
        CloseHandle(hf);
        data = h_buff;
        filename = buf;
        break;
    }
    case 1: /*  */
        data = buf;
        filename = NULL;
        break;
    default:
        return SPI_NO_FUNCTION;
}

    /* Ήt@CmF */
    if (GetFileType(data, filename) == FT_UNKNOWN) return SPI_NOT_SUPPORT;

    lpInfo->left       = 0;
    lpInfo->top        = 0;
    lpInfo->width      = 32;
    lpInfo->height     = 32;
    lpInfo->x_density  = 0;
    lpInfo->y_density  = 0;
    lpInfo->colorDepth = 24;
    lpInfo->hInfo      = NULL;

    return SPI_ALL_RIGHT;
}
//---------------------------------------------------------------------------
//GetPreviewGetPicturȅ܂Ƃ߂
int __fastcall GetPictureEx(
        const LPSTR buf, const long len, const unsigned int flag,
        HANDLE *pHBInfo, HANDLE *pHBm,
        const SPI_PROGRESS lpPrgressCallback,
        const long lData, const bool IsPreview)
{
    char h_buff[HEAD_BUFF];
    char *data;
    char *filename;
    bool inmem;

switch (flag & 7) {
    case 0: /* t@C */
    {
        HANDLE hf;
        DWORD ReadBytes;
        hf = CreateFile(buf, GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, 0, NULL);
        if (hf == INVALID_HANDLE_VALUE)
            return SPI_FILE_READ_ERROR;
        //SetFilePointer(hf, len, NULL, FILE_BEGIN);//MacoCiΉ
        if (!ReadFile(hf, h_buff, HEAD_BUFF, &ReadBytes, NULL)) {
            CloseHandle(hf);
            return SPI_FILE_READ_ERROR;
        }
        CloseHandle(hf);
        inmem = false;
        filename = buf;
        data = h_buff;
        break;
    }
    case 1: /*  */
        //ɓinjĐH
        if (!ifmmvar.GetOption(IFMMOPT_MemoryPlay)) {
            return SPI_NOT_SUPPORT;
        }
        data = buf;
        inmem = true;
        filename = NULL;
        break;
    default:
        return SPI_NO_FUNCTION;
}

    /* Ήt@CmF */
    unsigned int filetype = GetFileType(data, filename);
    if (filetype == FT_UNKNOWN) return SPI_NOT_SUPPORT;

    char tempfname[MAX_PATH] = "";
    //vr[łȂ΍Đ
    if (!IsPreview) {
        if (inmem) {
            if (!PutTempFile(tempfname, buf, len))
                return SPI_FILE_READ_ERROR;
        } else {
            strcat(tempfname, buf);
        }
        int ret = MediaPlay(tempfname, inmem, filetype, lpPrgressCallback, lData);
        if (inmem) DeleteFile(tempfname);
        if (ret != SPI_ALL_RIGHT) return ret;
        //"킴ƃG["ԂBԂ̂͂ȂƂȂuG[v
        if (ifmmvar.GetOption(IFMMOPT_ReturnErr)) return SPI_OTHER_ERROR;
    }

    bool ret;
    if (   !ifmmvar.GetOption(IFMMOPT_PreviewMovie)
        || !IsPreview
        || !IS_MOVIE(filetype)
       ) {
        ret = GetFileIcon(pHBInfo, pHBm, filetype);
        if (!ret) return SPI_OTHER_ERROR;
    } else {
        if (inmem) {
            if (!PutTempFile(tempfname, buf, len))
                return SPI_FILE_READ_ERROR;
            ret = GetMovieFrame(tempfname, pHBInfo, pHBm);
            DeleteFile(tempfname);
        } else {
            strcpy(tempfname, buf);
            ret = GetMovieFrame(tempfname, pHBInfo, pHBm);
        }
        if (!ret) {
            ret = GetFileIcon(pHBInfo, pHBm, filetype);
            if (!ret) return SPI_OTHER_ERROR;
        }
    }

    return SPI_ALL_RIGHT;
}
//---------------------------------------------------------------------------
int __stdcall GetPicture(
        LPSTR buf, long len, unsigned int flag,
        HANDLE *pHBInfo, HANDLE *pHBm,
        SPI_PROGRESS lpPrgressCallback, long lData)
{
    if (ifmmvar.GetOption(IFMMOPT_IsViX) && ifmmvar.GetOption(IFMMOPT_PlayByViX)) {
        //ViXōĐ
        return SPI_OTHER_ERROR;
    }
if (!ifmmvar.GetOption(IFMMOPT_IsSusie) && ifmmvar.GetOption(IFMMOPT_SusieOnly)) {
    //Susie݊ȊO
    return GetPreview(buf, len, flag, pHBInfo, pHBm, lpPrgressCallback, lData);
}
    //Susie݊
    return GetPictureEx(buf, len, flag, pHBInfo, pHBm, lpPrgressCallback, lData, false);
}
//---------------------------------------------------------------------------
int __stdcall GetPreview(
    LPSTR buf, long len, unsigned int flag,
    HANDLE *pHBInfo, HANDLE *pHBm,
    SPI_PROGRESS lpPrgressCallback, long lData)
{
    if (lpPrgressCallback != NULL)
        if (lpPrgressCallback(0, 1, lData)) // 0%
            return SPI_ABORT;

    int ret = GetPictureEx(buf, len, flag, pHBInfo, pHBm, lpPrgressCallback, lData, true);

    if (lpPrgressCallback != NULL)
        if (lpPrgressCallback(1, 1, lData)) // 100%
            return SPI_ABORT;

    return ret;
}
//---------------------------------------------------------------------------
int __stdcall ConfigurationDlg(HWND parent, int fnc)
{
//#define SPI_CFGDLG_ABOUT    0
#define SPI_CFGDLG_SETTING  1
//#define SPI_CFGDLG_RESERVED 2

    TDialogForm *DialogForm;

    if (fnc == SPI_CFGDLG_SETTING) {
#ifdef SetDlgH
        DialogForm = new TDialogForm(parent);
#else
        DialogForm = new TDialogForm(NULL);
#endif
        DialogForm->FormInit();
        DialogForm->ShowModal();
        delete DialogForm;
        return SPI_ALL_RIGHT;
    }
    return SPI_NO_FUNCTION;
}
//---------------------------------------------------------------------------



